CMSIS-NN: arm_nn_mat_mult_s8.c File Reference

| CMSIS-NN Version 1.3.0 CMSIS NN Software Library

- Main Page
- Usage and Description
- Reference

All Data Structures Namespaces Files Functions Variables Enumerations Enumerator Macros Groups Pages
Functions
arm_nn_mat_mult_s8.c File Reference

## Functions

q7_t * | arm_nn_mat_mult_s8 (const q7_t *input_row, const q7_t *input_col, const uint16_t output_ch, const uint16_t col_batches, const int32_t *output_shift, const int32_t *output_mult, const int32_t out_offset, const int32_t col_offset, const int32_t row_offset, const int16_t activation_min, const int16_t activation_max, const uint16_t row_len, const int32_t *const bias, q7_t *out)
| General Matrix-multiplication function with per-channel requantization. More...

## Function Documentation

q7_t* arm_nn_mat_mult_s8 | ( | const q7_t * | input_row,
|  | const q7_t * | input_col,
|  | const uint16_t | output_ch,
|  | const uint16_t | col_batches,
|  | const int32_t * | output_shift,
|  | const int32_t * | output_mult,
|  | const int32_t | out_offset,
|  | const int32_t | col_offset,
|  | const int32_t | row_offset,
|  | const int16_t | out_activation_min,
|  | const int16_t | out_activation_max,
|  | const uint16_t | row_len,
|  | const int32_t *const | bias,
|  | q7_t * | out
| ) |  |

Parameters

  [in] | input_row | pointer to row operand
  [in] | input_col | pointer to col operand
  [in] | output_ch | number of rows of input_row
  [in] | col_batches | number of column batches. Range: 1 to 4
  [in] | output_shift | pointer to per output channel requantization shift parameter.
  [in] | output_mult | pointer to per output channel requantization multiplier parameter.
  [in] | out_offset | output tensor offset.
  [in] | col_offset | input tensor(col) offset.
  [in] | row_offset | kernel offset(row). Not used.
  [in] | out_activation_min | minimum value to clamp the output to. Range : int8
  [in] | out_activation_max | maximum value to clamp the output to. Range : int8
  [in] | row_len | number of elements in each row
  [in] | bias | per output channel bias. Range : int32
  [in,out] | out | pointer to output

Returns
  The function returns one of the two
  1. The incremented output pointer for a successful operation or
  2. NULL if implementation is not available.

Supported framework: TensorFlow Lite

References arm_nn_requantize(), MAX, and MIN.

Referenced by arm_convolve_s8().